% neuron.m

% Zobrazowanie waciwoci iloczynu skalarnego
% na przykadzie wektorw dwuwymiarowych.
%
% Sygna wyjciowy neuronu y jest tym wikszy 
% im bardziej pooenie wektora x przypomina 
% pooenie wektora wag w.
% [Tade93]

% wektor sygnaw wejciowych x
x=[1; 1];
xnorm=normc(x);	% normowanie x

% wektor w1 wspczynnikw wagowych neuronu
w1=[-1; -1];
w1norm=normc(w1);	% normowanie w1


% wektor w2 wspczynnikw wagowych neuronu
w2=[-1; 1];
w2norm=normc(w2);	% normowanie w2


% wektor w3 wspczynnikw wagowych neuronu
w3=[0; 1];
w3norm=normc(w3);	% normowanie w3


% wektor w4 wspczynnikw wagowych neuronu
w4=[0.9; 1];
w4norm=normc(w4);	% normowanie w4

% iloczyny skalarne (zapis macierzowy)
y1=w1norm'*xnorm;
y2=w2norm'*xnorm;
y3=w3norm'*xnorm;
y4=w4norm'*xnorm;

% zobrazowanie wektora xnorm oraz 
% unormowanych wektorw w1, w2, w3, w4
figure(1);
rys2d(1, 4, 'xnorm', xnorm(1), xnorm(2));
hold on
rys2d(1, 4, 'w1norm', w1norm(1), w1norm(2), 'r-');
subplot(2,2,1); title('Unormowane wektory x i w1');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(y1)]);

rys2d(2, 4, 'xnorm', xnorm(1), xnorm(2));
hold on
rys2d(2, 4, 'w2norm', w2norm(1), w2norm(2), 'r-');
subplot(2,2,2); title('Unormowane wektory x i w2');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(y2)]);

rys2d(3, 4, 'xnorm', xnorm(1), xnorm(2));
hold on
rys2d(3, 4, 'w3norm', w3norm(1), w3norm(2), 'r-');
subplot(2,2,3); title('Unormowane wektory x i w3');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(y3)]);

rys2d(4, 4, 'xnorm', xnorm(1), xnorm(2));
hold on
rys2d(4, 4, 'w4norm', w4norm(1), w4norm(2), 'r-');
subplot(2,2,4); title('Unormowane wektory x i w4');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(y4)]);

% wywietlenie wartoci unormowanych wektorw: 
% x, w1, w2, w3, w4
xnorm
w1norm
w2norm
w3norm
w4norm

% Neuron rozpoznaje te sygnay wejciowe, ktre s
% podobne do jego wektora wag.
% [Tade93]

% Literatura
% Tade93		R. Tadeusiewicz: "Sieci Neuronowe", Akademicka Oficyna Wydawnicza,
%				Warszawa 1993



% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
