function rys2d(nr_wykr, ile_wykr, nazwa_wektora, a, b, styl)
% Funkcja rysujca wektor o wsprzdnych [a b]
% zaczepiony w pocztku ukadu wsprzdznych.
%
% ile_wykr - okrela liczb wygresw na jednym rysunku 
% dozwolone wartoci: 
% 4 - cztery wykresy
% 2 - dwa wykresy
% 1 - jeden wykres
%
% Dozwlone style to: 'r-', 'g-', 'b-', 'k-'
%
% ! ta funkcja pozostawia zawsze: hold off !

if nargin<5 error('Za mao argumentw !'); end
if nargin<6 styl='b-'; end
if nargin>6 error('Za duo argumentw !'); end

t=0:.1:1;
if ile_wykr==1,
   subplot(1,1,1); 
end
if ile_wykr==2,
   subplot(1,2,nr_wykr); 
end
if ile_wykr==4,
   subplot(2,2,nr_wykr); 
end
plot(a*t, b*t, styl);
hold on

% grot strzaki
grot1a=[a*t(8)+0.05*sign(b), a*t(9)+0.02*sign(b), a*t(10)+0.01*sign(b), a*t(11)];
grot1b=[b*t(8)-0.05*sign(a), b*t(9)-0.02*sign(a), b*t(10)-0.01*sign(a), b*t(11)];
plot(grot1a, grot1b, styl);
grot2a=[a*t(8)-0.05*sign(b), a*t(9)-0.02*sign(b), a*t(10)-0.01*sign(b), a*t(11)];
grot2b=[b*t(8)+0.05*sign(a), b*t(9)+0.02*sign(a), b*t(10)+0.01*sign(a), b*t(11)];
plot(grot2a, grot2b, styl);

% podpisy wektorw
if styl=='r-'
  H=text(a(1)*0.1+0.05, b*0.1,nazwa_wektora);
  set(H,'Color',[0.4 0 0]);
end
if styl=='g-'
  H=text(a(1)*0.3+0.05, b*0.3,nazwa_wektora);
  set(H,'Color',[0 0.4 0]);
end
if styl=='b-'
  H=text(a(1)*0.5+0.05, b*0.5,nazwa_wektora);
  set(H,'Color',[0 0 0.4]);
end
if styl=='k-'
  H=text(a(1)*0.7+0.05, b*0.7,nazwa_wektora);
  set(H,'Color',[0 0 0]);
end

hold off
grid on;
axis([-1 1 -1 1]);



% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
