function rys3d(n_plot, nazwa_wektora, a, b, c, styl)
% Funkcja rysujca wektor o wsprzdnych [a b c]
% zaczepiony w pocztku ukadu wsprzdznych.
%
% Jeli n_plot = 0: to funkcja wykorzystuje
% zwyky wykres.
% Jeli n_plot = 1..4 to funkcja wykorzystuje
% opcj subplot rysowania czterech podwykresw.
%
% Dozwlone style to: 'r-', 'g-', 'b-', 'k-'
%
% ! ta funkcja pozostawia zawsze: hold off !

if nargin<5, error('Za mao argumentw !'); end
if nargin<6, styl='b-'; end
if nargin>6, error('Za duo argumentw !'); end

t=0:.1:1;
if n_plot>0
   subplot(2,2,n_plot); 
end
plot3(a*t, b*t, c*t, styl);
hold on

% grot strzaki
grot1a=[a*t(8)+0.05*sign(b), a*t(9)+0.02*sign(b), a*t(10)+0.01*sign(b), a*t(11)];
grot1b=[b*t(8)-0.05*sign(c), b*t(9)-0.02*sign(c), b*t(10)-0.01*sign(c), b*t(11)];
grot1c=[c*t(8)-0.05*sign(a), c*t(9)-0.02*sign(a), c*t(10)-0.01*sign(a), c*t(11)];
plot3(grot1a, grot1b, grot1c, styl);
grot2a=[a*t(8)-0.05*sign(b), a*t(9)-0.02*sign(b), a*t(10)-0.01*sign(b), a*t(11)];
grot2b=[b*t(8)+0.05*sign(c), b*t(9)+0.02*sign(c), b*t(10)+0.01*sign(c), b*t(11)];
grot2c=[c*t(8)-0.05*sign(a), c*t(9)-0.02*sign(a), c*t(10)-0.01*sign(a), c*t(11)];
plot3(grot2a, grot2b, grot2c, styl);
grot3a=[a*t(8)-0.05*sign(b), a*t(9)-0.01*sign(b), a*t(10)-0.01*sign(b), a*t(11)];
grot3b=[b*t(8)-0.05*sign(c), b*t(9)-0.01*sign(c), b*t(10)-0.01*sign(c), b*t(11)];
grot3c=[c*t(8)+0.05*sign(a), c*t(9)+0.01*sign(a), c*t(10)+0.01*sign(a), c*t(11)];
plot3(grot3a, grot3b, grot3c, styl);

% podpisy wektorw
if styl=='r-'
  H=text(a(1)*0.1+0.05, b*0.1-0.05, c*0.1, nazwa_wektora);
  set(H,'Color',[0.4 0 0]);
end
if styl=='g-'
  H=text(a(1)*0.3+0.05, b*0.3-0.05, c*0.3, nazwa_wektora);
  set(H,'Color',[0 0.4 0]);
end
if styl=='b-'
  H=text(a(1)*0.5+0.05, b*0.5-0.05, c*0.5, nazwa_wektora);
  set(H,'Color',[0 0 0.4]);
end
if styl=='k-'
  H=text(a(1)*0.7+0.05, b*0.7-0.05, c*0.7, nazwa_wektora);
  set(H,'Color',[0 0 0]);
end

hold off
grid on;
axis([-1 1 -1 1 -1 1]);



% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
