% uczn_zn.m

% Uczenie neuronu (z nauczycielem)

% Uczenie rozpoznawania wektora A.
% Wektorem wejciowym podczas nauczania jest wektor A

% wspczynnik eta (decyduje o szybkoci uczenia)
eta=0.6;
% dany sygna wyjciowy (dana odpowied neuronu)
z=1;

% wektor A
A=[1; 1];
Anorm=normc(A);	% normowanie wektora A

% wyrysowanie wektora A
figure(1);
rys2d(1, 1, 'A', Anorm(1), Anorm(2));
hold on

% wektor wspczynnikw wagowych neuronu
% (na pocztku przyjmuje wartoci losowe)
w0=randn(2,1);
w0norm=normc(w0);	% normowanie wektora w0

w=w0norm; % wektor w jest wic ju unormowany

% rysowanie unormowanego wektora w0 
% (w0 - pocztkowy wektor wag neuronu)
rys2d(1, 1, 'w0', w0norm(1), w0norm(2), 'r-');
hold on

% proces uczenia (64 kroki)
for i=1:64
   y=w'*Anorm;
   delta=z-y;
   w=w+eta*delta*Anorm;
   w=normc(w);
   if i == 1
      % wyrysowanie unormowanego wektora wag po 1 kroku nauczania
      rys2d(1, 1, 'w1', w(1), w(2), 'g-');
      hold on
   end
   if i == 8
      % wyrysowanie unormowanego wektora wag po 8 kroku nauczania
      rys2d(1, 1, 'w8', w(1), w(2), 'r-');
      hold on
   end
   if i == 64
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      rys2d(1, 1, 'w64', w(1), w(2), 'g-');
   end
end
xlabel('X1'); ylabel('X2'); title('Uczenie pojedynczego neuronu (z nauczycielem)');
text(-0.9, -0.65, 'w0 - pocztkowy wektor wag neuronu');
text(-0.9, -0.75, 'w1 - wektor wag neuronu po 1 kroku nauczania');
text(-0.9, -0.85, 'w8 - wektor wag neuronu po 8 kroku nauczania');
text(-0.9, -0.95, 'w64 - wektor wag neuronu po 64 krokach nauczania');
% UWAGA !
% Wyrysowane wektory s unormowane, jednake aby nie zaciemnia
% rysunku podpisane s bez dodatkowego oznaczenia "norm"

% wyswietlenie wartoci:
% - unormowanego wektora - A
% - unormowanego pocztkowego wektora wartoci 
%   wspczynnikw wagowych neuronu - w0
% - unormowanego kocowego (po 64 krokach)
%   wektora wartoci wspczynnikw neuronu - w
Anorm
w0norm
wnorm=w % unormowany podczas uczenia



% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
