% uczn_zn1.m

% Uczenie neuronu (z nauczycielem)

% Uczenie rozpoznawania wektora A.
% Wektorem wejciowym podczas nauczania jest wektor A

% wspczynnik eta (decyduje o szybkoci uczenia)
eta1=0.6;
eta2=0.1;
% dany sygna wyjciowy (dana odpowied neuronu)
z=1;

% wektor A
A=[1; 1];
Anorm=normc(A);	% normowanie wektora A

% wyrysowanie wektora A
figure(1);
rys2d(1, 1, 'A', Anorm(1), Anorm(2), 'k-');
hold on

% wektor wspczynnikw wagowych neuronu
% (na pocztku przyjmuje wartoci losowe)
w0=randn(2,1);
w0norm=normc(w0);	% normowanie wektora w0

w1=w0norm;
w2=w0norm;

% rysowanie unormowanego wektora w0 
% (w0 - pocztkowy wektor wag neuronu)
rys2d(1, 1, 'w0', w0norm(1), w0norm(2), 'r-');
hold on

% proces uczenia (64 kroki)
for i=1:64
   y1=w1'*Anorm;	% eta: eta1=0.6
   delta1=z-y1;
   w1=w1+eta1*delta1*Anorm;
   w1=normc(w1);
   y2=w2'*Anorm;	% eta: eta2=0.2
   delta2=z-y2;
   w2=w2+eta2*delta2*Anorm;
   w2=normc(w2);
   if i == 1
      % wyrysowanie unormowanego wektora wag po 1 kroku nauczania
      rys2d(1, 1, 'w11', w1(1), w1(2), 'g-');
      hold on
      rys2d(1, 1, 'w21', w2(1), w2(2), 'b-');
      hold on
   end
   if i == 8
      % wyrysowanie unormowanego wektora wag po 8 kroku nauczania
      rys2d(1, 1, 'w18', w1(1), w1(2), 'g-');
      hold on
      rys2d(1, 1, 'w28', w2(1), w2(2), 'b-');
      hold on
   end
   if i == 64
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      rys2d(1, 1, 'w164', w1(1), w1(2), 'g-');
      hold on
      rys2d(1, 1, 'w264', w2(1), w2(2), 'b-');
   end
end
xlabel('X1'); ylabel('X2'); title('Uczenie pojedynczego neuronu (z nauczycielem)');
text(-0.9, -0.65, 'w0 - pocztkowy wektor wag neuronu');
text(-0.9, -0.75, 'wi1 - wektor wag i neuronu po 1 kroku nauczania');
text(-0.9, -0.85, 'wi8 - wektor wag i neuronu po 8 kroku nauczania');
text(-0.9, -0.95, 'wi64 - wektor wag i neuronu po 64 krokach nauczania');
% UWAGA !
% Wyrysowane wektory s unormowane, jednake aby nie zaciemnia
% rysunku podpisane s bez dodatkowego oznaczenia "norm"




% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
