% uczn_zn2.m

% Uczenie neuronu (z nauczycielem)

% Uczenie rozpoznawania wektora A.
% Wektorem wejciowym podczas nauczania jest wektor A

% wspczynnik eta (decyduje o szybkoci uczenia)
eta=0.6;
% dany sygna wyjciowy (dana odpowied neuronu)
z1=1;
z0=0;	% mona podstawi take inne wartoci, np. z0=-0.5
zx=-1;

% wektor A
A=[1; 1];
Anorm=normc(A);	% normowanie wektora A

% wyrysowanie wektora A
figure(1);
rys2d(1, 1, 'A', Anorm(1), Anorm(2), 'k-');
hold on

% wektor wspczynnikw wagowych neuronu
% (na pocztku przyjmuje wartoci losowe)
w0=randn(2,1);
w0norm=normc(w0);	% normowanie wektora w0

% dla wszystkich przypadkw zaczynamy z takiego samego
% stanu pocztkowego
w1=w0norm;	% dla z = z1 = 1
w0=w0norm;	% dla z = z0 = 0
wx=w0norm;	% dla z = zx = -1

% rysowanie unormowanego pocztkowego wektora wag neuronu
rys2d(1, 1, 'wpocz', w0norm(1), w0norm(2), 'k-');
hold on

% proces uczenia (64 kroki)
for i=1:64
   y1=w1'*Anorm;	% z1
   delta1=z1-y1;
   w1=w1+eta*delta1*Anorm;
   w1=normc(w1);
   y0=w0'*Anorm;	% z0
   delta0=z0-y0;
   w0=w0+eta*delta0*Anorm;
   w0=normc(w0);
   yx=wx'*Anorm;	% zx
   deltax=zx-yx;
   wx=wx+eta*deltax*Anorm;
   wx=normc(wx);
   if i == 1
      % wyrysowanie unormowanego wektora wag po 1 kroku nauczania
      rys2d(1, 1, 'w11', w1(1), w1(2), 'r-');
      hold on
      rys2d(1, 1, 'w01', w0(1), w0(2), 'g-');
      hold on
      rys2d(1, 1, 'wx1', wx(1), wx(2), 'b-');
      hold on
   end
   if i == 8
      % wyrysowanie unormowanego wektora wag po 8 kroku nauczania
      rys2d(1, 1, 'w18', w1(1), w1(2), 'r-');
      hold on
      rys2d(1, 1, 'w08', w0(1), w0(2), 'g-');
      hold on
      rys2d(1, 1, 'wx8', wx(1), wx(2), 'b-');
      hold on
   end
   if i == 64
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      rys2d(1, 1, 'w164', w1(1), w1(2), 'r-');
      hold on
      rys2d(1, 1, 'w064', w0(1), w0(2), 'g-');
      hold on
      rys2d(1, 1, 'wx64', wx(1), wx(2), 'b-');
   end
end
xlabel('X1'); ylabel('X2'); title('Uczenie pojedynczego neuronu (z nauczycielem)');
text(-0.9, -0.65, 'w0 - pocztkowy wektor wag neuronu');
text(-0.9, -0.75, 'wi1 - wektor wag i neuronu po 1 kroku nauczania');
text(-0.9, -0.85, 'wi8 - wektor wag i neuronu po 8 kroku nauczania');
text(-0.9, -0.95, 'wi64 - wektor wag i neuronu po 64 krokach nauczania');
% UWAGA !
% Wyrysowane wektory s unormowane, jednake aby nie zaciemnia
% rysunku podpisane s bez dodatkowego oznaczenia "norm"




% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
