% uczn_zn3.m

% Uczenie neuronu (z nauczycielem)

% Uczenie rozpoznawania wektora A.
% Wektorem wejciowym podczas nauczania jest nie tylko wektor A
% ale take inne wektory (dla nich dany sygna wejciowy jest
% inny) - udawane uczenie innych neuronw.

% wspczynnik eta (decyduje o szybkoci uczenia)
eta=0.6;
% dany sygna wyjciowy (dana odpowied neuronu)
z1=1;		% nauczanie neuronu
z0=-1;	% nauczanie innego neuronu
% z0=0;

% wektor A
A=[1; 1];
Anorm=normc(A);	% normowanie wektora A
% inny wektor 
C=[-1; -1];
C=normc(C);

% wyrysowanie wektora A i C
figure(1);
rys2d(1, 1, 'A', Anorm(1), Anorm(2), 'k-');
hold on
rys2d(1, 1, 'C', C(1), C(2), 'k-');
hold on

% wektor wspczynnikw wagowych neuronu
% (na pocztku przyjmuje wartoci losowe)
%w0=randn(2,1);
w0=[-0.3; -0.1];
w0norm=normc(w0);	% normowanie wektora w0

w=w0norm; % wektor w jest wic ju unormowany

% rysowanie unormowanego wektora w0 
% (w0 - pocztkowy wektor wag neuronu)
rys2d(1, 1, 'w0', w0norm(1), w0norm(2), 'r-');
hold on

% proces uczenia (64 kroki)
for i=1:64
   if mod(i, 2)==0, % uczenie wektorem A
   y=w'*Anorm;
   delta=z1-y;
   w=w+eta*delta*Anorm;
   w=normc(w);
   end
   if mod(i, 2)==1, % uczenie wektorem C
   y=w'*Anorm;
   delta=z0-y;
   w=w+eta*delta*C;
   w=normc(w);
   end
   if i == 1
      % wyrysowanie unormowanego wektora wag po 1 kroku nauczania
      rys2d(1, 1, 'w1', w(1), w(2), 'g-');
      hold on
   end
   if i == 2
      % wyrysowanie unormowanego wektora wag po 8 kroku nauczania
      rys2d(1, 1, 'w2', w(1), w(2), 'b-');
      hold on
   end
   if i == 3
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      rys2d(1, 1, 'w3', w(1), w(2), 'g-');
      hold on
   end
   if i == 4
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      rys2d(1, 1, 'w4', w(1), w(2), 'b-');
      hold on
   end
   if i == 63
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      rys2d(1, 1, 'w63', w(1), w(2), 'g-');
      hold on
   end
   if i == 64
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      rys2d(1, 1, 'w64', w(1), w(2), 'b-');
   end
end
xlabel('X1'); ylabel('X2'); title('Uczenie pojedynczego neuronu (z nauczycielem)');
text(-0.9, -0.85, 'w0 - pocztkowy wektor wag neuronu');
text(-0.9, -0.95, 'wi - wektor wag neuronu po i kroku nauczania');
% UWAGA !
% Wyrysowane wektory s unormowane, jednake aby nie zaciemnia
% rysunku podpisane s bez dodatkowego oznaczenia "norm"

% wyswietlenie wartoci:
% - unormowanego wektora - A
% - unormowanego pocztkowego wektora wartoci 
%   wspczynnikw wagowych neuronu - w0
% - unormowanego kocowego (po 64 krokach)
%   wektora wartoci wspczynnikw neuronu - w
Anorm
w0norm
wnorm=w % unormowany podczas uczenia



% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
