% uczw_zn1.m

% Uczenie dwuneuronowej warstwy (z nauczycielem)

% Uczenie rozpoznawania wektorw A i B.
% Wektorami wejciowymi podczas nauczania s wektory A i B

% wspczynnik eta (decyduje o szybkoci uczenia)
eta=0.6; % 10 - oscylacje
% dany sygna wyjciowy (dana odpowied neuronw)
zA=[1; 0];		% przy nauczaniu neuronu 1 wektorem A
zB=[0; 1];		% przy nauczaniu neuronu 2 wektorem B

% wektory A i B
A=[1; 1];
Anorm=normc(A);	
B=[-1; 1];
Bnorm=normc(B);

% wyrysowanie wektorw A i B
figure(1);
rys2d(1, 1, 'A', Anorm(1), Anorm(2), 'k-');
hold on
rys2d(1, 1, 'B', Bnorm(1), Bnorm(2), 'k-');
hold on
figure(2);
rys2d(1, 1, 'A', Anorm(1), Anorm(2), 'k-');
hold on
rys2d(1, 1, 'B', Bnorm(1), Bnorm(2), 'k-');
hold on

% wektory wspczynnikw wagowych neuronu
% (na pocztku przyjmuj wartoci losowe)
% wA0=randn(2,1);
wA0=[1; 0];
wA0norm=normc(wA0);	
wB0=wA0;
% wB0=randn(2,1);
wB0norm=normc(wB0);	

wA=wA0norm;
wB=wB0norm;
W=[wA'; wB'];
normr(W);

% rysowanie unormowanego wektora wA0 i wB0
% (wA0 - pocztkowy wektor wag neuronu A)
figure(1);
rys2d(1, 1, 'wA0', wA0norm(1), wA0norm(2), 'r-');
hold on
figure(2);
rys2d(1, 1, 'wB0', wB0norm(1), wB0norm(2), 'r-');
hold on

% proces uczenia (64 kroki)
for i=1:64
   if mod(i, 2)==0, % uczenie wektorem A
   Y=W*Anorm;
   delta=zA-Y;
   W=W+eta*delta*Anorm';
   W=normr(W);	% normowanie wierszy macierzy
   end
   if mod(i, 2)==1, % uczenie wektorem B
   Y=W*Bnorm;
   delta=zB-Y;
   W=W+eta*delta*Bnorm';
   W=normr(W); % normowanie wierszy macierzy
   end
   if i == 1
      % wyrysowanie unormowanego wektora wag po 1 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w1', w(1), w(2), 'g-');
      hold on
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w1', w(1), w(2), 'g-');
      hold on
   end
   if i == 2
      % wyrysowanie unormowanego wektora wag po 8 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w2', w(1), w(2), 'b-');
      hold on
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w2', w(1), w(2), 'b-');
      hold on
   end
   if i == 3
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w3', w(1), w(2), 'g-');
      hold on
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w3', w(1), w(2), 'g-');
      hold on
   end
   if i == 4
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w4', w(1), w(2), 'b-');
      hold on
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w4', w(1), w(2), 'b-');
      hold on
   end
   if i == 61
      % wyrysowanie unormowanego wektora wag po 1 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w61', w(1), w(2), 'g-');
      hold on
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w61', w(1), w(2), 'g-');
      hold on
   end
   if i == 62
      % wyrysowanie unormowanego wektora wag po 8 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w62', w(1), w(2), 'b-');
      hold on
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w62', w(1), w(2), 'b-');
      hold on
   end
   if i == 63
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w63', w(1), w(2), 'g-');
      hold on
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w63', w(1), w(2), 'g-');
      hold on
   end
   if i == 64
      % wyrysowanie unormowanego wektora wag po 64 kroku nauczania
      figure(1);
      w=W(1,:);
      rys2d(1, 1, 'w64', w(1), w(2), 'b-');
      figure(2);
      w=W(2,:);
      rys2d(1, 1, 'w64', w(1), w(2), 'b-');
   end
end
figure(1);
xlabel('X1'); ylabel('X2'); title('Uczenie neuronu 1 rozpoznawania wektora A');
text(-0.9, -0.85, 'w0 - pocztkowy wektor wag neuronu');
text(-0.9, -0.95, 'wi - wektor wag neuronu po i krokach nauczania');
figure(2);
xlabel('X1'); ylabel('X2'); title('Uczenie neuronu 2 rozpoznawania wektora B');
text(-0.9, -0.85, 'w0 - pocztkowy wektor wag neuronu');
text(-0.9, -0.95, 'wi - wektor wag neuronu po i krokach nauczania');
% UWAGA !
% Wyrysowane wektory s unormowane, jednake aby nie zaciemnia
% rysunku podpisane s bez dodatkowego oznaczenia "norm"




% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
