% wneur.m 

% Warstwa neuronw (na przykadzie wektorw dwuwymiarowych)

% Warstwa neuronw jest najprostsz sieci neuronow.
% Maksymalny sygna wyjciowy pojawia si na wyjciu 
% tego neuronu i, ktrego wektor wag wi najbardziej 
% przypomina wektor wejciowy x.
% Taka sie moe rozrnia tyle klas obiektw z ilu
% neuronw si skada.
% Badany sygna wejciowy jest zaliczany przez sie
% do tej klasy obiektw, dla ktrej sygna odpowiedniego
% neuronu jest najwikszy (maksymalny).
% [Tade93]

% W tym wiczeniu rozpatrujemy czteroneuronow warstw,
% ktr aktywujemy dwoma rnymi sygnaami wejciowymi.


% wektory wspczynnikw wagowych poszczeglnych neuronw
w1=[-1; -1];	%neuron 1
w1norm=normc(w1);	% normowanie w1
w2=[-1; 1];		% -"-
w2norm=normc(w2);	
w3=[0; 1];
w3norm=normc(w3);
w4=[1; 1];
w4norm=normc(w4);

% Macierz wspczynnikw wagowych czterech neurnw
W4=[w1norm'; w2norm'; w3norm'; w4norm'];

% zobrazowanie unormowanych wektorw poszczeglnych 
% neuronw i wektorw wejciowych x1 i x2 
% oraz wynik rozpoznawania 

% WEKTOR x1
x1=[-0.3; -0.7];
x1norm=normc(x1);	% normowanie wektora x1

% Rozpoznawanie
Y1=W4*x1norm;

figure(1);
rys2d(1, 4, 'x1norm', x1norm(1), x1norm(2));
hold on
rys2d(1, 4, 'w1norm', w1norm(1), w1norm(2), 'r-');
subplot(2,2,1); xlabel('X1'); ylabel('X2'); title('Neuron 1');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y1(1))]);

rys2d(2, 4, 'x1norm', x1norm(1), x1norm(2));
hold on
rys2d(2, 4, 'w2norm', w2norm(1), w2norm(2), 'r-');
subplot(2,2,2); xlabel('X1'); ylabel('X2'); title('Neuron 2');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y1(2))]);

rys2d(3, 4, 'x1norm', x1norm(1), x1norm(2));
hold on
rys2d(3, 4, 'w3norm', w3norm(1), w3norm(2), 'r-');
subplot(2,2,3); xlabel('X1'); ylabel('X2'); title('Neuron 3');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y1(3))]);

rys2d(4, 4, 'x1norm', x1norm(1), x1norm(2));
hold on
rys2d(4, 4, 'w4norm', w4norm(1), w4norm(2), 'r-');
subplot(2,2,4); xlabel('X1'); ylabel('X2'); title('Neuron 4');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y1(4))]);

% WEKTOR x2
x2=[0.3; 0.9];
x2norm=normc(x2);	% normowanie wektora x2

% Rozpoznawanie
Y2=W4*x2norm;

figure(2);
rys2d(1, 4, 'x2norm', x2norm(1), x2norm(2));
hold on
rys2d(1, 4, 'w1norm', w1norm(1), w1norm(2), 'r-');
subplot(2,2,1); xlabel('X1'); ylabel('X2'); title('Neuron 1');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y2(1))]);

rys2d(2, 4, 'x2norm', x2norm(1), x2norm(2));
hold on
rys2d(2, 4, 'w2norm', w2norm(1), w2norm(2), 'r-');
subplot(2,2,2); xlabel('X1'); ylabel('X2'); title('Neuron 2');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y2(2))]);

rys2d(3, 4, 'x2norm', x2norm(1), x2norm(2));
hold on
rys2d(3, 4, 'w3norm', w3norm(1), w3norm(2), 'r-');
subplot(2,2,3); xlabel('X1'); ylabel('X2'); title('Neuron 3');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y2(3))]);

rys2d(4, 4, 'x2norm', x2norm(1), x2norm(2));
hold on
rys2d(4, 4, 'w4norm', w4norm(1), w4norm(2), 'r-');
subplot(2,2,4); xlabel('X1'); ylabel('X2'); title('Neuron 4');
text(-0.9, -0.75, ['Iloczyn skalarny: ',num2str(Y2(4))]);

% Do ktrej klasy: w1, w2, w3, czy w4 mona zaliczy wektor wejiowy x1?
% A do ktrej x2?

% Literatura
% Tade93		R. Tadeusiewicz: "Sieci Neuronowe", Akademicka Oficyna Wydawnicza,
%				Warszawa 1993



% Autor: mgr in. Adam Goda
% golda@agh.edu.pl
